(function() {
  var PureRenderMixin, React, T, code, cx, div, hljs, lengthLimit, pre;

  cx = require('classnames');

  hljs = require('highlight.js/lib/highlight');

  React = require('react');

  PureRenderMixin = require('react-addons-pure-render-mixin');

  code = React.createFactory('code');

  div = React.createFactory('div');

  pre = React.createFactory('pre');

  T = React.PropTypes;

  hljs.configure({
    tabReplace: '  '
  });

  lengthLimit = 100 * 1000;

  module.exports = React.createClass({
    displayName: 'lite-code-viewer',
    mixins: [PureRenderMixin],
    propTypes: {
      codeType: T.string,
      name: T.string,
      text: T.string
    },
    getDefaultProps: function() {
      return {
        codeType: 'nohighlight',
        text: ''
      };
    },
    renderCode: function() {
      return hljs.highlightAuto(this.props.text, [this.props.codeType]).value;
    },
    render: function() {
      var className, obj;
      className = cx((
        obj = {
          'lite-code-viewer': true
        },
        obj["is-for-" + this.props.name] = this.props.name != null,
        obj
      ));
      return div({
        className: className,
        ref: 'viewer'
      }, pre(null, this.props.text.length > lengthLimit ? code({
        className: this.props.codeType
      }, this.props.text) : code({
        className: this.props.codeType,
        dangerouslySetInnerHTML: {
          __html: this.renderCode()
        }
      })));
    }
  });

}).call(this);
